Skip to example

Parallax

Scroll-linked parallax effect where background images move at a different speed to foreground content, creating a sense of depth.

This parallax effect is scroll-linked: each background moves more slowly than the page, so it appears further away. useScroll tracks each section's progress through the viewport, and useTransform maps that progress to the image's y offset and the caption's opacity.

React
>Ship this

Use this in your own site

This is not just a demo to learn from. Motion+ unlocks the full, production-ready source so you can copy it straight into your own project and ship it.

Source code

Tutorial

Tutorial time
5 min
Difficulty

Introduction

The Parallax example shows how to build a full-page scrolling gallery where background images move at a different speed to the foreground text, creating a sense of depth. It also fades text in and out as each section moves through the viewport.

It uses three APIs from Motion:

  • useScroll to track how far each section has scrolled through the viewport
  • useTransform to map that scroll progress to image position and text opacity/position values
  • The motion component to apply those values as live styles

Get started

We'll build the page as a list of sections, each containing a background image and an overlay with a title and subtitle. Here's the starter markup:

"use client"

import { useRef } from "react"

interface SectionData {
    image: string
    title: string
    subtitle: string
}

const SECTIONS: SectionData[] = [
    {
        image: "your-image-1.jpg",
        title: "Title 1",
        subtitle: "Subtitle 1",
    },
    {
        image: "your-image-2.jpg",
        title: "Title 2",
        subtitle: "Subtitle 2",
    },
]

const ParallaxSection = ({
    image,
    title,
    subtitle,
}: SectionData) => {
    const ref = useRef(null)

    return (
        <section ref={ref} className="parallax-section">
            <div className="parallax-bg">
                <img src={image} alt={title} />
            </div>
            <div className="parallax-overlay" />
            <div className="parallax-content">
                <h2 className="parallax-title">{title}</h2>
                <p className="parallax-subtitle">{subtitle}</p>
            </div>
        </section>
    )
}

export default function Parallax() {
    return (
        <div className="parallax-page">
            {SECTIONS.map((section, i) => (
                <ParallaxSection key={i} index={i} {...section} />
            ))}
        </div>
    )
}

<style>
    /** Copy styles from example source code */
</style>

Each section is 100vh tall and has overflow: hidden so that the background image - which is taller than the section - gets clipped as it moves. The parallax-overlay is a semi-transparent gradient layered over the image to make the text readable.

Skip to example

Parallax

An example of creating a parallax effect using Motion for Vue's useScroll hook.

Vue

Source code

<script setup lang="tsx">
/** @jsxImportSource vue */
import { motion, useScroll, useSpring, useTransform } from 'motion-v'
import { ref,defineComponent } from 'vue'

function useParallax(value, distance) {
  return useTransform(value, [0, 1], [-distance, distance])
}


const Image = defineComponent({
  props: {
    id: {
      type: Number,
      required: true
    }
  },
  setup(props) {
    const targetRef = ref(null)
    const { scrollYProgress } = useScroll({ target: targetRef })
    const y = useParallax(scrollYProgress, 300)
    
    return () => (
      <section class="img-container">
        <div ref={targetRef}>
          <img
            src={`/photos/cityscape/${props.id}.jpg`}
            alt="A London skyscraper"
          />
        </div>
        <motion.h2
          // Hide until scroll progress is measured
          initial={{ visibility: "hidden" }}
          animate={{ visibility: "visible" }}
          style={{ y }}
        >{`#00${props.id}`}</motion.h2>
      </section>
    )
  }
})
const progress = useSpring(useScroll().scrollYProgress, {
        stiffness: 100,
        damping: 30,
        restDelta: 0.001
      })
</script>

<template>
  <div id="example">
    <Image v-for="image in [1, 2, 3, 4, 5]" :key="image" :id="image" />
    <motion.div 
      class="progress" 
      :style="{ scaleX: progress }" 
    />
  </div>
</template>

<style>
html {
  scroll-snap-type: y mandatory;
}

.img-container {
  height: 100vh;
  scroll-snap-align: start;
  display: flex;
  justify-content: center;
  align-items: center;
  position: relative;
}

.img-container > div {
  width: 300px;
  height: 400px;
  margin: 20px;
  background: #f5f5f5;
  overflow: hidden;
}

.img-container img {
  width: 300px;
  height: 400px;
}

@media (max-width: 500px) {
  .img-container > div {
    width: 150px;
    height: 200px;
  }

  .img-container img {
    width: 150px;
    height: 200px;
  }
}

.img-container h2 {
  color: #4ff0b7;
  margin: 0;
  font-family: "Geist Mono", monospace;
  font-size: 50px;
  font-weight: 700;
  letter-spacing: -3px;
  line-height: 1.2;
  position: absolute;
  display: inline-block;
  top: calc(50% - 25px);
  left: calc(50% + 120px);
}

.progress {
  position: fixed;
  left: 0;
  right: 0;
  height: 5px;
  background: #4ff0b7;
  bottom: 50px;
  transform: scaleX(0);
}
</style>